%%  Plot IRFS

nshocks = length(shockNames);

whatToPlot = 'Median-Bands';            % Choose either 'All' or 'Median-Bands'

hmaxtoplot = 12;                        % Maxmum Horizon of IRFs for plot

bands  = [16,50,84];                    % Percentiles for bands

f = figure(2);
set(f, 'color', 'white');
clf
figSize = [12 6];
set(f, 'PaperUnits', 'inches');
set(f, 'Units','inches');
set(f, 'PaperSize', figSize);
set(f, 'PaperPositionMode', 'auto');
set(f, 'Position', [0 0 figSize(1) figSize(2)])


load('FigureA2_supply')

subplot(1,3,1)

temp=[ynk(1:17) yhnk(1:17) ybnk(1:17) yhbnk(1:17)];
h = plot(0:16,temp);
set(h,{'linestyle'},{'-'; '-'; '-';'-.'});
set(h,{'Marker'},{'s'; 'o'; '*';'none'});
set(h,{'LineWidth'},{[2]; [2]; [2]; [3.5]});
set(h, {'color'}, {[0 0 0];[0 0 1];[1 0 0];[0.4940, 0.1840, 0.5560]});
title('Output Gap','FontSize',12);

subplot(1,3,2)

temp=[pink(1:17) pihnk(1:17) pibnk(1:17) pihbnk(1:17)];
h = plot(0:16,temp);
set(h,{'linestyle'},{'-'; '-'; '-';'-.'});
set(h,{'Marker'},{'s'; 'o'; '*';'none'});
set(h,{'LineWidth'},{[2]; [2]; [2]; [3.5]});
set(h, {'color'}, {[0 0 0];[0 0 1];[1 0 0];[0.4940, 0.1840, 0.5560]});
title('Inflation','FontSize',12);

subplot(1,3,3)

temp=[ink(1:17) ihnk(1:17) ibnk(1:17) ihbnk(1:17)];
h = plot(0:16,temp);
set(h,{'linestyle'},{'-'; '-'; '-';'-.'});
set(h,{'Marker'},{'s'; 'o'; '*';'none'});
set(h,{'LineWidth'},{[2]; [2]; [2]; [3.5]});
set(h, {'color'}, {[0 0 0];[0 0 1];[1 0 0];[0.4940, 0.1840, 0.5560]});

xlim([0 16])
title('Nominal Rate','FontSize',12);


hold on

count = 1;
for jj = 2:2
    
    for ii = 1:3;
        
        
        subplot(1,3,count)
        
        relevantIRFs = squeeze(Draws_IRFs(ii,jj,1:hmaxtoplot+1,:));
        if ~isempty(NSR)
        relevantIRFs_narrative = squeeze(Draws_IRFs_narrative(ii,jj,1:hmaxtoplot+1,:));
        end
        
        switch whatToPlot
            case 'Median-Bands'
                 percentiles1 = prctile(relevantIRFs,bands,2);                   % Compute percentiles
               
                 plotConfidenceBandsBlue(0:hmaxtoplot,percentiles1,'r');         % Plot the percentiles

                
                
            case 'All'
                
                plot(0:hmaxtoplot,relevantIRFs,'color',[0.0 0.0 1 0.1]);        % Plot the IRFs themselves
                hold on
                
                if ~isempty(NSR)
                plot(0:hmaxtoplot,relevantIRFs_narrative,'color',[1 0 0 1]);        % Plot the IRFs themselves
                end
                
        end
        
      
        % Plot the zero line
        hold on
        
        plot(0:hmaxtoplot,zeros(hmaxtoplot+1,1),'--k')
        
        % Axes.
        
        xmin=0;
        xmax=hmaxtoplot;
        xlim([xmin,xmax])

      
        set(gca, 'FontSize', 12);
         set(gca,'XTick',[0:round(hmaxtoplot/4.33):hmaxtoplot]')
         set(gca,'XTickLabel',num2str([0:round(hmaxtoplot/4.33):hmaxtoplot]'))
        box on
        
       
        title(strcat({' '},varNames(ii),{' '}))
      
        
        count  = count+1;
        xlabel('Time') 
    end
   
end

legend( 'NK','HNK', 'BNK', 'BHNK', 'VAR 68% CI','VAR median');
