% Compute matrices:

Ay=[oo_.dr.ghx(11,5),oo_.dr.ghx(11,6),oo_.dr.ghx(11,1)];
Api=[oo_.dr.ghx(12,5),oo_.dr.ghx(12,6),oo_.dr.ghx(12,1)];
Ai=[oo_.dr.ghx(7,5),oo_.dr.ghx(7,6),oo_.dr.ghx(7,1)];

A=[Ay; Api; Ai];

By=[oo_.dr.ghu(11,1)/oo_.posterior_median.parameters.sig_d,oo_.dr.ghu(11,2)/oo_.posterior_median.parameters.sig_s,oo_.dr.ghu(11,3)/oo_.posterior_median.parameters.sig_i];
Bpi=[oo_.dr.ghu(12,1)/oo_.posterior_median.parameters.sig_d,oo_.dr.ghu(12,2)/oo_.posterior_median.parameters.sig_s,oo_.dr.ghu(12,3)/oo_.posterior_median.parameters.sig_i];
Bi=[oo_.dr.ghu(7,1)/oo_.posterior_median.parameters.sig_d,oo_.dr.ghu(7,2)/oo_.posterior_median.parameters.sig_s,oo_.dr.ghu(7,3)/oo_.posterior_median.parameters.sig_i];

B=[By; Bpi; Bi];

R=[oo_.posterior_median.parameters.rho_d 0 0; 0 oo_.posterior_median.parameters.rho_s 0; 0 0 oo_.posterior_median.parameters.rho_i];


% Extract simulated data:

y_simulacion=y_sim(6798:end-3,:); 
pi_simulacion=pi_sim(6798:end-3,:); 
i_nom_simulacion=i_nom_sim(6798:end-3,:); 

e_d_simulacion=e_d_sim(6798:end-3,:); 
e_s_simulacion=e_s_sim(6798:end-3,:); 
e_i_simulacion=e_i_sim(6798:end-3,:); 

y_simulacionminus1=yminus1_sim(6798:end-3,:); 
pi_simulacionminus1=piminus1_sim(6798:end-3,:); 
i_nom_simulacionminus1=i_nomminus1_sim(6798:end-3,:); 

e_d_simulacionminus1=e_dminus1_sim(6798:end-3,:); 
e_s_simulacionminus1=e_sminus1_sim(6798:end-3,:); 
e_i_simulacionminus1=e_iminus1_sim(6798:end-3,:); 

e_d_simulacionplus1=e_d_sim(6799:end-2,:); 
e_s_simulacionplus1=e_s_sim(6799:end-2,:); 
e_i_simulacionplus1=e_i_sim(6799:end-2,:); 

e_d_simulacionplus2=e_d_sim(6800:end-1,:); 
e_s_simulacionplus2=e_s_sim(6800:end-1,:); 
e_i_simulacionplus2=e_i_sim(6800:end-1,:); 

e_d_simulacionplus3=e_d_sim(6801:end,:); 
e_s_simulacionplus3=e_s_sim(6801:end,:); 
e_i_simulacionplus3=e_i_sim(6801:end,:); 


x=[y_simulacion pi_simulacion i_nom_simulacion];
u=[e_d_simulacion e_s_simulacion e_i_simulacion];

xminus1=[y_simulacionminus1 pi_simulacionminus1 i_nom_simulacionminus1];
uminus1=[e_d_simulacionminus1 e_s_simulacionminus1 e_i_simulacionminus1];
uplus1=[e_d_simulacionplus1 e_s_simulacionplus1 e_i_simulacionplus1];
uplus2=[e_d_simulacionplus2 e_s_simulacionplus2 e_i_simulacionplus2];
uplus3=[e_d_simulacionplus3 e_s_simulacionplus3 e_i_simulacionplus3];


%Introduce FE and FR:

FE = A.*(1-mbar_c)*x.' + B*uplus1.' - mbar_c.*B*R*u.' + A.^2*x.' + A*B*uplus1.' + B*uplus2.' - mbar_c^2.*(A.^2*x.' + A*B*R*u.' + B*R.^2*u.') + ...
    A.^3*x.' + A.^2*B*uplus1.' + A*B*uplus2.' + B*uplus3.' - mbar_c^3.*(A.^3*x.' + A.^2*B*R*u.' + A*B*R.^2*u.' + B*R.^3*u.');

FR = x.' - mbar_c.*(A*xminus1.' + B*R*uminus1.') + ...
    mbar_c.*(A*x.' + B*R*u.') - mbar_c^2.*(A.^2*xminus1.' + A*B*R*uminus1.' + B*R.^2*uminus1.') + ...
    mbar_c^2.*(A.^2*x.' + A*B*R*u.' + B*R.^2*u.') - mbar_c^3.*(A.^3*xminus1.' + A.^2*B*R*uminus1.' + A*B*R.^2*uminus1.' + B*R.^3*uminus1.') + ...
    mbar_c^3.*(A.^3*x.' + A.^2*B*R*u.' + A*B*R.^2*u.' + B*R.^3*u.') - mbar_c^4.*(A.^4*xminus1.' + A.^3*B*R*uminus1.' + A.^2*B*R.^2*uminus1.' + A*B*R.^3*uminus1.' + B*R.^4*uminus1.');


% Compute beta:

betaEMy=FR(1,:).'\FE(1,:).';
betaEMpi=FR(2,:).'\FE(2,:).';
betaEM = [betaEMy, betaEMpi]';
